local myname="ZifnabsHUD"
local Me=CreateFrame("Frame",myname)
if not ZifnabsMod then ZifnabsMod={hud=Me} else ZifnabsMod.hud=Me end
local mod
local L
local db
local widget={}
local queue={}
local timer=0
local scroll=0

-- --------------------------------------------------------------------------------------
-- INITIALIZE
-- --------------------------------------------------------------------------------------
function Me:Initialize(fwinfo)
	mod=fwinfo.mod
	L=fwinfo.L
	db=fwinfo.db
	if not db.hud then db.hud={scroll=5, queuescroll=1.5} end
	widget.hud={}
	for t=1,3,1 do
		widget.hud[t]={text=mod.ui:addText(myname.."_Text_1",300,30,UIParent,"CENTER","TOP",0,-20-30*t+(t*t),19-(t*t),"CENTER","TOP")}
		widget.hud[t].text:SetTextColor(1,(t-1)/2,0)
		-- TODO create icon holder
	end
	mod.core:Register4Event("ONUPDATE","hud",Me.OnUpdate)
end

-- --------------------------------------------------------------------------------------
-- WRITE
-- --------------------------------------------------------------------------------------
function Me:write(text,sound,icon) 
	text=mod.f:Trim(text)
	if text~="" or icon then queue[1+#queue]={text=text,sound=sound,icon=icon} end
end

-- --------------------------------------------------------------------------------------
-- ONUPDATE
-- --------------------------------------------------------------------------------------
function Me:OnUpdate(elapsed)
	timer=timer+elapsed
	if timer-scroll>=db.hud.scroll or (#queue>0 and timer-scroll>db.hud.queuescroll) then
		widget.hud[3].text:SetText(widget.hud[2].text:GetText())
		widget.hud[2].text:SetText(widget.hud[1].text:GetText())
		if #queue==0 then widget.hud[1].text:SetText("")
		else
			widget.hud[1].text:SetText(queue[1].text)
			if queue[1].sound then mod.f:Sound(queue[1].sound) end
			tremove(queue,1)
		end
		scroll=timer
	end
end